#include <stdio.h>
#include <stdlib.h>

void dbl_array(int a[], int n) {
    int i;
    for (i = 0; i < n; i++) {
        a[i] *= 2;
    }
}

void print_array(int a[], int n) {
    int i;
    for (i = 0; i < n; i++) {
        printf("%d ", a[i]);
    }
    printf("\n");
}

int binary_search(int a[], int n, int x) {
    int l = 0;
    int r = n-1;

    while (l <= r) {
        int m = (l + r)/2;
        if (a[m] < x) {
            l = m + 1;
        }
        else if (a[m] > x) {
            r = m - 1;
        }
        else {
            return 1;
        }
    }

    return 0;
}

void print_mat(int mat[][100], int m, int n) {
    int i, j;
    for (i = 0; i < m; i++) {
        for (j = 0; j < n; j++) {
            printf("%d ", mat[i][j]);
        }
        printf("\n");
    }
}

void transpose(int mat[][100], int n) {
    int i, j;
    for (i = 0; i < n-1; i++) {
        for (j = i+1; j < n; j++) {
            int tmp = mat[i][j];
            mat[i][j] = mat[j][i];
            mat[j][i] = tmp;
        }
    }
}

int main()
{
    int c[10], c2[20];
    c[0] = 1;
    printf("%d\n", c[0]);

    //int a[5] = {1,2,3,4,5};
    //int a[5] = {0};
    //int a[5] = {1,2,3};
    int a[] = {1,2,3,4,5};
    int i;
    for (i = 0; i < 5; i++) {
        printf("%d ", a[i]);
    }
    printf("\n");

    int n = 5;
    int s = 0;
    for (i = 0; i < n; i++) {
        s += a[i];
    }
    printf("%d\n", s);

    int x[] = { 1, 2, 6, 4, 8, 5, 9, 7, 8, 10,
                1, 6, 3, 8, 6, 10, 3, 8, 2, 7, 6, 5, 7, 6, 8, 6, 7, 5, 6, 6,
                5, 6, 7, 5, 6, 4, 8, 6, 8, 10 };
    n = 40;
    int y[11] = {0};

    for (i = 0; i < n; i++) {
        y[x[i]]++;
    }

    int j;
    for (j = 1; j <= 10; j++) {
        printf("%3d %3d\n", j, y[j]);
    }

    int max_idx = 1;
    for (j = 2; j <= 10; j++) {
        if (y[max_idx] < y[j]) {
            max_idx = j;
        }
    }
    printf("Najcesci je %d\n", max_idx);

    print_array(a, 5);
    dbl_array(a, 5);
    print_array(a, 5);

    int mat[100][100] = { { 1, 2, 3 }, { 4, 5, 6 }, { 7, 8, 9 } };
    //int mat[2][2] = { 1, 2, 3, 4 };
    //int mat[2][2] = {0};
    for (i = 0; i < 3; i++) {
        for (j = 0; j < 3; j++) {
            printf("%d ", mat[i][j]);
        }
        printf("\n");
    }
    printf("\n");

    print_mat(mat, 3, 3);
    printf("\n");
    transpose(mat, 3);
    print_mat(mat, 3, 3);

    int arr[] = {2, 5, 9, 14, 21, 25, 32};
    printf("%d\n", binary_search(arr, 7, 25));
    printf("%d\n", binary_search(arr, 7, 22));
    printf("%d\n", binary_search(arr, 7, 5));

    return 0;
}
